<template>
  <client-only>
    <file-pond
      ref="pond"
      label-idle="Arrastra y suelta aquí el archivo a cargar<br>(Archivos soportados: csv, xlsx)"
      :accepted-file-types="typesAllowed"
      :allow-multiple="false"
      @addfile="handleFile"
      @processfileabort="handleFile"
      @processfileundo="handleFile"
      @removefile="handleFile"
    />
  </client-only>
</template>

<script>
import vueFilePond from 'vue-filepond';
import 'filepond/dist/filepond.min.css';

import FilePondPluginFileValidateType from 'filepond-plugin-file-validate-type';

const FilePond = vueFilePond(
  FilePondPluginFileValidateType,
);

export default {
  name: 'FilePondUpload',
  components: {
    FilePond,
  },
  props: {
    fileTypesAllowed: {
      type: Array,
      default: () => [
        'text/csv',
        'application/vnd.ms-excel',
        'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet',
        'application/vnd.ms-excel',
      ],
    },
  },
  emits: ['file-uploaded'],
  computed: {
    typesAllowed() {
      return this.fileTypesAllowed.join(', ');
    },
  },
  methods: {
    handleFile() {
      const file = this.$refs.pond.getFile() ?? {};
      this.$emit('file-uploaded', file);
    },
  },
};
</script>
